Attribute VB_Name = "modItem"
' modItem.bas

''''''''''''''''''''''''''''''''''''''''''''''''''''

' Revisions Notes

' June 6, 2005
'  - init uses external file

''''''''''''''''''''''''''''''''''''''''''''''''''''


Option Explicit


Type ItemDefType
    Name As String
    Image As Integer
    
    flgBlockMovement As Boolean
    flgMovable As Boolean

    Damage As Long
    Armor As Long

End Type

Global ItemDef() As ItemDefType


Type ItemType
    flgInUse As Boolean
    
    ID As Integer
    
    Xpos As Long
    Ypos As Long

    Quantity As Long

End Type

Global Item() As ItemType

Global EmptyItem As ItemType



''' Original code submitted by Jon, 6/6/2005
Sub modItem_Init()
    On Error GoTo errHandle
    
    ReDim Item(1 To 1000)
    
    Dim lFileNum As Long
    Dim strData As String
    Dim iNumber As Integer
    
    lFileNum = FreeFile
    Open App.Path & "\item.ini" For Input As #lFileNum
        
    ' first find the max
    Do Until EOF(lFileNum)
        Line Input #lFileNum, strData
    
        If UCase$(Left$(strData, 5)) = "ITEM=" Then
            If iNumber < Int(Trim$(Right$(strData, Len(strData) - 5))) Then
                iNumber = Int(Trim$(Right$(strData, Len(strData) - 5)))
            End If
        End If
    Loop
        
    ReDim ItemDef(1 To iNumber)
        
    iNumber = 0
        
    ' rewind to beginning
    Seek #lFileNum, 1
            
    ' ok, now read them all in
    Do Until EOF(lFileNum)
        Line Input #lFileNum, strData
    
        If Left$(strData, 1) = ";" Or Len(Trim$(strData)) = 0 Then
            ' remark, just ignore
        
        ElseIf UCase$(Left$(strData, 5)) = "ITEM=" Then
            'Set the current item number
            iNumber = Int(Trim$(Right$(strData, Len(strData) - 5)))
        
        ElseIf UCase$(Left$(strData, 5)) = "NAME=" Then
            ItemDef(iNumber).Name = Trim$(Right$(strData, Len(strData) - 5))
        
        ElseIf UCase$(Left$(strData, 6)) = "IMAGE=" Then
            ItemDef(iNumber).Image = Int(Trim$(Right$(strData, Len(strData) - 6)))
        
        ElseIf UCase$(Left$(strData, 7)) = "DAMAGE=" Then
            ItemDef(iNumber).Damage = Int(Trim$(Right$(strData, Len(strData) - 7)))
        
        ElseIf UCase$(Left$(strData, 6)) = "ARMOR=" Then
            ItemDef(iNumber).Armor = Int(Trim$(Right$(strData, Len(strData) - 6)))
        
        ElseIf UCase$(Left$(strData, 13)) = "BLOCKMOVEMENT" Then
            ItemDef(iNumber).flgBlockMovement = True
        
        ElseIf UCase$(Left$(strData, 7)) = "MOVABLE" Then
            ItemDef(iNumber).flgMovable = True
        
        Else
            'Unknown command found
            MsgBox "Unknown line found in item.ini" & vbCrLf & strData, vbExclamation, "WARNING!!!!"
        
        End If
    
    Loop
    
    Close #lFileNum

    Exit Sub
errHandle:
    MsgBox "Error_modItem_Init: " & Err.Description & " Item#=" & iNumber
End Sub


''' OLD INIT before file support
'''Sub modItem_Init()
'''    ReDim Item(1 To 1000)
'''
'''    ' in rpgwo these item definitions are stord in an .ini file and loaded
'''    ' but for simplicity I manually add them
'''
'''    ReDim ItemDef(1 To 100)
'''
'''    ItemDef(1).Name = "Stone Wall"
'''    ItemDef(1).Image = 1
'''    ItemDef(1).flgBlockMovement = True
'''
'''    ItemDef(2).Name = "Stone Wall"
'''    ItemDef(2).Image = 2
'''    ItemDef(2).flgBlockMovement = True
'''
'''    ItemDef(3).Name = "Stone Wall"
'''    ItemDef(3).Image = 3
'''    ItemDef(3).flgBlockMovement = True
'''
'''    ItemDef(4).Name = "Stone Wall"
'''    ItemDef(4).Image = 4
'''    ItemDef(4).flgBlockMovement = True
'''
'''    ItemDef(5).Name = "Stone Wall"
'''    ItemDef(5).Image = 5
'''    ItemDef(5).flgBlockMovement = True
'''
'''    ItemDef(6).Name = "Stone Wall"
'''    ItemDef(6).Image = 6
'''    ItemDef(6).flgBlockMovement = True
'''
'''    ItemDef(7).Name = "Stone Wall"
'''    ItemDef(7).Image = 7
'''    ItemDef(7).flgBlockMovement = True
'''
'''    ItemDef(8).Name = "Stone Wall"
'''    ItemDef(8).Image = 8
'''    ItemDef(8).flgBlockMovement = True
'''
'''    ItemDef(9).Name = "Stone Wall"
'''    ItemDef(9).Image = 9
'''    ItemDef(9).flgBlockMovement = True
'''
'''    ItemDef(10).Name = "Stone Wall"
'''    ItemDef(10).Image = 10
'''    ItemDef(10).flgBlockMovement = True
'''
'''    ItemDef(11).Name = "Stone Wall"
'''    ItemDef(11).Image = 11
'''    ItemDef(11).flgBlockMovement = True
'''
'''    ItemDef(12).Name = "Stone Wall"
'''    ItemDef(12).Image = 12
'''    ItemDef(12).flgBlockMovement = True
'''
'''    ItemDef(13).Name = "Stone Wall"
'''    ItemDef(13).Image = 13
'''    ItemDef(13).flgBlockMovement = True
'''
'''    ItemDef(14).Name = "Stone Wall"
'''    ItemDef(14).Image = 14
'''    ItemDef(14).flgBlockMovement = True
'''
'''    ItemDef(15).Name = "Stone Wall"
'''    ItemDef(15).Image = 15
'''    ItemDef(15).flgBlockMovement = True
'''
'''    ItemDef(16).Name = "Stone Wall"
'''    ItemDef(16).Image = 16
'''    ItemDef(16).flgBlockMovement = True
'''
'''
'''    ItemDef(17).Name = "Closed Door"
'''    ItemDef(17).Image = 17
'''    ItemDef(17).flgBlockMovement = True
'''
'''    ItemDef(18).Name = "Open Door"
'''    ItemDef(18).Image = 18
'''
'''
'''    ItemDef(19).Name = "Closed Door"
'''    ItemDef(19).Image = 20
'''    ItemDef(19).flgBlockMovement = True
'''
'''    ItemDef(20).Name = "Open Door"
'''    ItemDef(20).Image = 21
'''
'''    ItemDef(21).Name = "Stairs Down"
'''    ItemDef(21).Image = 22
'''
'''    ItemDef(22).Name = "Stairs Up"
'''    ItemDef(22).Image = 23
'''
'''    ItemDef(23).Name = "Dead Giant Rat"
'''    ItemDef(23).Image = 24
'''
'''    ItemDef(24).Name = "Small Pile of Gold"
'''    ItemDef(24).Image = 19
'''
'''    ItemDef(25).Name = "Large Pile of Gold"
'''    ItemDef(25).Image = 29
'''
'''    ItemDef(26).Name = "Dead Asp"
'''    ItemDef(26).Image = 25
'''
'''    ItemDef(27).Name = "Dagger"
'''    ItemDef(27).Image = 30
'''    ItemDef(27).flgMovable = True
'''    ItemDef(27).Damage = 3
'''
'''    ItemDef(28).Name = "Short Sword"
'''    ItemDef(28).Image = 31
'''    ItemDef(28).flgMovable = True
'''    ItemDef(28).Damage = 5
'''
'''    ItemDef(29).Name = "Long Sword"
'''    ItemDef(29).Image = 32
'''    ItemDef(29).flgMovable = True
'''    ItemDef(29).Damage = 7
'''
'''    ItemDef(30).Name = "Broad Sword"
'''    ItemDef(30).Image = 33
'''    ItemDef(30).flgMovable = True
'''    ItemDef(30).Damage = 9
'''
'''    ItemDef(31).Name = "Great Sword"
'''    ItemDef(31).Image = 34
'''    ItemDef(31).flgMovable = True
'''    ItemDef(31).Damage = 11
'''
'''    ItemDef(32).Name = "Soft Leather Armor"
'''    ItemDef(32).Image = 26
'''    ItemDef(32).flgMovable = True
'''    ItemDef(32).Armor = 2
'''
'''    ItemDef(33).Name = "Hard Leather Armor"
'''    ItemDef(33).Image = 27
'''    ItemDef(33).flgMovable = True
'''    ItemDef(33).Armor = 4
'''
'''    ItemDef(34).Name = "Studded Leather Armor"
'''    ItemDef(34).Image = 28
'''    ItemDef(34).flgMovable = True
'''    ItemDef(34).Armor = 6
'''
'''
'''End Sub


Function modItem_Add(ByVal ID As Integer, ByVal Xpos As Long, ByVal Ypos As Long) As Long
    On Error GoTo Error_modItem_Add

    ' MAJOR PITFALL!!!!
    ' If you pass as an argument anything that references the Item array
    ' and the function tries to resize the array you will get an array locked error!!!
    ' So use temp variables not tied to Item() array to pass

    ' make sure in bounds
    If Not Map_Check(Xpos, Ypos) Then Exit Function
    
    ' make sure the spot is free
    If ItemMap(Xpos, Ypos) <> 0 Then Exit Function

    Dim i As Long, iIndex As Long
    
    ' find a place for them in the array
    For i = 1 To UBound(Item)
        If Not Item(i).flgInUse Then
            iIndex = i
            Exit For
        End If
    Next i

    ' see if found a place
    If iIndex = 0 Then
        ' no free place so resize the array
        ReDim Preserve Item(1 To UBound(Item) + 1000)
        iIndex = UBound(Item) - 9
    End If

    ' ok, set the data
    Item(iIndex).flgInUse = True
    Item(iIndex).ID = ID
    Item(iIndex).Xpos = Xpos
    Item(iIndex).Ypos = Ypos

    ' set the map to point to the array index
    ItemMap(Xpos, Ypos) = iIndex

    modItem_Add = iIndex

    Exit Function
    
Error_modItem_Add:
    MsgBox "Error_modItem_Add : " & Err.Description
End Function


Sub modItem_Delete(ByVal iIndex As Long)
    On Error GoTo Error_modItem_Delete

    If iIndex = 0 Then Exit Sub

    ItemMap(Item(iIndex).Xpos, Item(iIndex).Ypos) = 0
    
    Item(iIndex) = EmptyItem

    Exit Sub
    
Error_modItem_Delete:
    MsgBox "Error_modItem_Delete : " & Err.Description
End Sub


Sub modItem_Open(ByVal pIndex As Long)
    On Error GoTo Error_modItem_Open

    ' use the players facing
    
    Dim Xpos As Long, Ypos As Long
    
    Xpos = Player(pIndex).Xpos
    Ypos = Player(pIndex).Ypos
    
    If Not modMap_Get_Facing_XY(Player(pIndex).Facing, Xpos, Ypos) Then Exit Sub
    
    Dim iIndex As Long
    
    iIndex = ItemMap(Xpos, Ypos)
    
    If iIndex = 0 Then Exit Sub
    
    modPlayer_Auto_Action pIndex, iIndex

    Exit Sub
    
Error_modItem_Open:
    MsgBox "Error-modItem_Open : " & Err.Description
End Sub


Sub modItem_Step_On(pIndex As Long, Xpos As Long, Ypos As Long)
    On Error GoTo Error_modItem_Step_On

    Dim iIndex As Long
    
    iIndex = ItemMap(Xpos, Ypos)
    
    If iIndex = 0 Then Exit Sub

    Select Case Item(iIndex).ID
        Case 21
            ' stairs down
            modMap_Load App.Path & "/" & Map.Lower & ".map"
                        
            modSound_Play SOUND_DOWN
        
        Case 22
            ' stairs up
            modMap_Load App.Path & "/" & Map.Upper & ".map"
                
            modSound_Play SOUND_UP
            
        Case 24, 25
            ' gold
            If pIndex = Game.pIndex Then
                Dim Gold As Long
                If Item(iIndex).ID = 24 Then
                    ' small pile
                    Gold = Rnd * 5 + 5
                Else
                    ' large pile
                    Gold = Rnd * 10 + 10
                End If
                Player(pIndex).Gold = Player(pIndex).Gold + Gold
                modMessage_Add "You pick up " & Gold & " gold!", vbBlue
                modItem_Delete iIndex
                
                modSound_Play SOUND_BEEP1
            End If
                
    End Select

    Exit Sub
    
Error_modItem_Step_On:
    MsgBox "Error_modItem_Step_On : " & Err.Description
End Sub


Function modItem_ID(strName As String) As Integer
    On Error GoTo Error_modItem_ID

    Dim i As Integer
    
    For i = 1 To UBound(ItemDef)
        If UCase$(Trim$(ItemDef(i).Name)) = UCase$(Trim$(strName)) Then
            modItem_ID = i
            Exit Function
        End If
    Next i

    Exit Function
    
Error_modItem_ID:
    MsgBox "Error_modItem_ID : " & Err.Description
End Function


Sub modItem_Pickup(pIndex As Long)
    On Error GoTo Error_modItem_Pickup

    Dim Xpos As Long, Ypos As Long
    
    Xpos = Player(pIndex).Xpos
    Ypos = Player(pIndex).Ypos
    
    If Not modMap_Get_Facing_XY(Player(pIndex).Facing, Xpos, Ypos) Then Exit Sub

    Dim iIndex As Long
    
    iIndex = ItemMap(Xpos, Ypos)
    
    ' see if an item is there
    If iIndex = 0 Then
        ' nothing in front of, check underneath
        Xpos = Player(pIndex).Xpos
        Ypos = Player(pIndex).Ypos
        
        iIndex = ItemMap(Xpos, Ypos)
        
        If iIndex = 0 Then Exit Sub
        
    End If

    ' see if movable
    If Not ItemDef(Item(iIndex).ID).flgMovable Then Exit Sub

    Dim i As Long, cIndex As Long
    
    ' find a free spot
    For i = 1 To MAX_CARRY
        If Not Player(pIndex).Carry(i).flgInUse Then
            cIndex = i
            Exit For
        End If
    Next i

    If cIndex = 0 Then
        ' inventory is full
        If Game.pIndex = pIndex Then
            modMessage_Add Trim$(Player(pIndex).Name) & "'s inventory is full!", vbYellow
        End If
        
        Exit Sub
    End If

    ' ok, pick it up, yo
    Player(pIndex).Carry(cIndex) = Item(iIndex)
    
    ' remove it from map
    modItem_Delete iIndex

    modSound_Play SOUND_BEEP2

    Exit Sub
    
Error_modItem_Pickup:
    MsgBox "Error_modItem_Pickup : " & Err.Description
End Sub


Sub modItem_Drop(pIndex As Long, cIndex As Long)
    On Error GoTo Error_modItem_Drop

    Dim pXpos As Long, pYpos As Long
    
    pXpos = Player(pIndex).Xpos
    pYpos = Player(pIndex).Ypos
    
    If Not modMap_Get_Facing_XY(Player(pIndex).Facing, pXpos, pYpos) Then
        pXpos = Player(pIndex).Xpos
        pYpos = Player(pIndex).Ypos
    End If

    Dim i As Long, j As Long, k As Long
    Dim Xpos As Long, Ypos As Long, iIndex As Long

    ' find a place to drop, expand search as needed
    
    For k = 0 To 3
    
        For i = -k To k
            For j = -k To k
            
                Xpos = pXpos + i
                Ypos = pYpos + j
            
                If Map_Check(Xpos, Ypos) Then
                    
                    ' see if clear
                    If ItemMap(Xpos, Ypos) = 0 Then
                        ' found a spot
                        
                        ' create a temp item on the map
                        iIndex = modItem_Add(Player(pIndex).Carry(cIndex).ID, Xpos, Ypos)
                        
                        ' make sure it is valid
                        If iIndex > 0 Then
                            Item(iIndex) = Player(pIndex).Carry(cIndex)
                            Item(iIndex).Xpos = Xpos
                            Item(iIndex).Ypos = Ypos
                            Player(pIndex).Carry(cIndex) = EmptyItem
                            
                            ' seeif it was armed
                            If Player(pIndex).Weapon = cIndex Then
                                Player(pIndex).Weapon = 0
                            End If
                            
                            ' seeif it was armed
                            If Player(pIndex).Armor = cIndex Then
                                Player(pIndex).Armor = 0
                            End If
                            
                            Exit Sub
                        End If
                        
                    End If
                    
                End If
            
            Next j
        Next i
    
    Next k
    
    ' no room on ground
    
    If pIndex = Game.pIndex Then
        modMessage_Add "No room to drop item.", vbYellow
    End If
    
    Exit Sub
    
Error_modItem_Drop:
    MsgBox "Error_modItem_Drop : " & Err.Description
End Sub


Sub modItem_Arm_Weapon(pIndex As Long, cIndex As Long)
    On Error GoTo Error_modItem_Arm_Weapon

    ' see if a weapon
    If ItemDef(Player(pIndex).Carry(cIndex).ID).Damage > 0 Then
        If Player(pIndex).Weapon = cIndex Then
            ' un-ready
            Player(pIndex).Weapon = 0
        Else
            ' ready
            Player(pIndex).Weapon = cIndex
        End If
    
    ElseIf ItemDef(Player(pIndex).Carry(cIndex).ID).Armor > 0 Then
        If Player(pIndex).Armor = cIndex Then
            ' un-ready
            Player(pIndex).Armor = 0
        Else
            ' ready
            Player(pIndex).Armor = cIndex
        End If
    End If
    
    modSound_Play SOUND_READY

    Exit Sub
    
Error_modItem_Arm_Weapon:
    MsgBox "Error_modItem_Arm_Weapon : " & Err.Description
End Sub


Function modItem_Weapon_Damage(pIndex As Long) As Long
    On Error GoTo Error_modItem_Weapon_Damage

    Dim ItemID As Integer

    If Player(pIndex).Weapon = 0 Then
        ' bare hands
        modItem_Weapon_Damage = Int(Rnd * 2) + 1
        
        ' see if a monster
        If Player(pIndex).ID > 0 Then
            ' boost the default
            modItem_Weapon_Damage = modItem_Weapon_Damage * Player(pIndex).Level
        End If
    Else
        ' get armed
        ItemID = Player(pIndex).Carry(Player(pIndex).Weapon).ID
        
        ' +/- 2
        modItem_Weapon_Damage = Int(Rnd * 4) - 2 + ItemDef(ItemID).Damage
        
    End If
    
    If modItem_Weapon_Damage <= 0 Then
        modItem_Weapon_Damage = 1
    End If

    Exit Function
    
Error_modItem_Weapon_Damage:
    MsgBox "Error_modItem_Weapon_Damage : " & Err.Description
End Function


Function modItem_Armor(pIndex As Long) As Long
    On Error GoTo Error_modItem_Armor

    If Player(pIndex).Armor <> 0 Then
    
        modItem_Armor = ItemDef(Player(pIndex).Carry(Player(pIndex).Armor).ID).Armor
    
        ' give 50% to 100% of Armor value
        modItem_Armor = Int(Rnd * (modItem_Armor / 2)) + modItem_Armor / 2
    
    End If

    Exit Function
    
Error_modItem_Armor:
    MsgBox "Error_modItem_Armor : " & Err.Description
End Function
